// OSHW Logo Generator
// Open Source Hardware Logo : http://oshwlogo.com/
// -------------------------------------------------
//
// Adapted from Adrew Plumb/ClothBot original version
// just change internal parameters to made dimension control easier
// a single parameter : logo diameter (millimeters)
//
// oshw_logo_2D(diameter) generate a 2D logo with diameter requested
// just have to extrude to get a 3D version, then add it to your objects
//
// cc-by-sa, pierre-alain dorange, july 2012

//
// With updates by RepRap Italia users: 
// NinjamCrew 
// Pivan (dual extrusion / colors code)
//

// dual extrusion: generate two STL:
// A) color1=1, color2=0, render, export STL. 
// B) color1=0, color2=1, render, export STL.
//
// single extuder
// A) color1=1, color2=1, render, export STL

// what
color1=1;
color2=1;

Nickname = "PIVAN";
Reprap = "RepRap";

// danger below this line :)


use <Write.scad>

module gear_tooth_2d(d) {
	polygon( points=[ 
			[0.0,10.0*d/72.0], [0.5*d,d/15.0], 
			[0.5*d,-d/15.0], [0.0,-10.0*d/72.0] ] );
}

module oshw_logo_2d(d=10.0) {
	rotate(-135) {
		difference() {
			union() {
				circle(r=14.0*d/36.0,$fn=20);
				for(i=[1:7]) assign(rotAngle=45*i+45)
					rotate(rotAngle) gear_tooth_2d(d);
			}
			circle(r=10.0*d/72.0,$fn=20);
			intersection() {
	  			rotate(-20) square(size=[10.0*d/18.0,10.0*d/18.0]);
	  			rotate(20)  square(size=[10.0*d/18.0,10.0*d/18.0]);
			}
    		}
  	}
}

if (color2 == 1) {

// usage : oshw_logo_2d(diameter)
 linear_extrude(height=2)
 oshw_logo_2d(25);
 translate([0,6,2])
 write(font = "Orbitron.dxf","RepRap",t=2,h=4,center=true);
}



$fn=50;

if (color1 == 1) {

  difference() {

	translate([-15,-22,-0.9]) minkowski()
		{
 			cube([30,40,0.5]);
 			cylinder(r=2,h=0.5);
		}

	translate([0,17,-5]) cylinder(d=3,h=10);
  
  }
}
if (color2 == 1) {
	translate([0,-15,0.9]) 
		write(font = "Letters.dxf", Nickname, t=1,h=4,center=true);
}

if (color1 == 1) {
// RepRap txt
	translate([0,6,2]) 
		write(font = "Letters.dxf", Reprap, t=0.6,h=3,center=true);
}

